package edu.cornell.cs.cs4120.xth.xic;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import edu.cornell.cs.cs4120.xth.BuildTest;

/**
 *
 */
public class XicBuildTest extends BuildTest {

    public static final String BUILD_NAME = "xic-build";

    public XicBuildTest() {
        super(BUILD_NAME);
    }

    @Override
    protected int invokeCompilerBuilder(File dir) {
        String buildCmd = dir.getAbsolutePath() + File.separator + BUILD_NAME;
        // Check existence of build command
        File builder = new File(buildCmd);
        if (!builder.isFile()) {
            appendFailureMessage("File " + buildCmd + " does not exist.");
            return -3;
        }
        ProcessBuilder pb = new ProcessBuilder(buildCmd);
        pb.directory(dir);
        try {
            Process p = pb.start();
            InputStream outStream = p.getInputStream(); // normal output of the shell
            InputStream errStream = p.getErrorStream(); // error output of the shell
            try (InputStreamReader or = new InputStreamReader(outStream);
                 InputStreamReader er = new InputStreamReader(errStream);
                 BufferedReader osr = new BufferedReader(or);
                 BufferedReader esr = new BufferedReader(er)) {
                String line = null;
                while ((line = osr.readLine()) != null)
                    System.out.println(line);
                while ((line = esr.readLine()) != null)
                    System.err.println(line);
            }
            return p.waitFor();
        }
        catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return -1;
        }
        catch (IOException e) {
            appendFailureMessage(e.getMessage());
            return -2;
        }
    }
}
